summaryrefslogtreecommitdiffstats
path: root/source/l/gtk+3
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2012-09-26 01:10:42 +0000
committer Eric Hameleers <alien@slackware.com>2018-05-31 22:51:55 +0200
commit9664bee729d487bcc0a0bc35859f8e13d5421c75 (patch)
treeb428a16618e36ed864a8d76ea3435e19a452bf90 /source/l/gtk+3
parent75a4a592e5ccda30715f93563d741b83e0dcf39e (diff)
downloadcurrent-9664bee729d487bcc0a0bc35859f8e13d5421c75.tar.gz
current-9664bee729d487bcc0a0bc35859f8e13d5421c75.tar.xz
Slackware 14.0slackware-14.0
Wed Sep 26 01:10:42 UTC 2012 Slackware 14.0 x86_64 stable is released! We're perfectionists here at Slackware, so this release has been a long time a-brewing. But we think you'll agree that it was worth the wait. Slackware 14.0 combines modern components, ease of use, and flexible configuration... our "KISS" philosophy demands it. The ISOs are off to be replicated, a 6 CD-ROM 32-bit set and a dual-sided 32-bit/64-bit x86/x86_64 DVD. Please consider supporting the Slackware project by picking up a copy from store.slackware.com. We're taking pre-orders now, and offer a discount if you sign up for a subscription. Thanks to everyone who helped make this happen. The Slackware team, the upstream developers, and (of course) the awesome Slackware user community. Have fun! :-)
Diffstat (limited to 'source/l/gtk+3')
-rw-r--r--source/l/gtk+3/doinst.sh28
-rwxr-xr-xsource/l/gtk+3/gtk+3.SlackBuild188
-rw-r--r--source/l/gtk+3/slack-desc19
-rw-r--r--source/l/gtk+3/update-gtk-immodules-3.086
-rw-r--r--source/l/gtk+3/use_host_triplet_for_gtk_immodules.diff11
5 files changed, 332 insertions, 0 deletions
diff --git a/source/l/gtk+3/doinst.sh b/source/l/gtk+3/doinst.sh
new file mode 100644
index 000000000..90d1085fe
--- /dev/null
+++ b/source/l/gtk+3/doinst.sh
@@ -0,0 +1,28 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/gtk-3.0/gtkrc.new
+config etc/gtk-3.0/im-multipress.conf.new
+rm -f etc/gtk-3.0/gtkrc.new
+
+chroot . rm -f /usr/share/icons/*/icon-theme.cache 1> /dev/null 2> /dev/null
+
+# Run this if we are on an installed system. Otherwise it will be
+# handled on first boot.
+if [ -x /usr/bin/update-gtk-immodules-3.0 ]; then
+ /usr/bin/update-gtk-immodules-3.0
+fi
+
+# In case this is the first run installing the standalone gdk-pixbuf,
+# we will run this a second time to fix machines that will not reboot.
+chroot . /usr/bin/update-gdk-pixbuf-loaders 1> /dev/null 2> /dev/null
+
diff --git a/source/l/gtk+3/gtk+3.SlackBuild b/source/l/gtk+3/gtk+3.SlackBuild
new file mode 100755
index 000000000..c4e972eb5
--- /dev/null
+++ b/source/l/gtk+3/gtk+3.SlackBuild
@@ -0,0 +1,188 @@
+#!/bin/sh
+
+# Copyright 2008, 2009, 2010, 2011 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+VERSION=${VERSION:-$(echo gtk+-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-gtk3
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG/usr
+cd $TMP
+rm -rf gtk+-$VERSION
+tar xvf $CWD/gtk+-$VERSION.tar.?z* || exit 1
+cd gtk+-$VERSION
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Use /etc/gtk-3.0/$ARCH-slackware-linux instead of /etc/gtk-3.0/ for gtk.immodules
+zcat $CWD/use_host_triplet_for_gtk_immodules.diff.gz | patch -p1 --verbose || exit 1
+
+# Regenerate ./configure:
+libtoolize --copy --force
+autoreconf -vif
+
+# Autoconf changes linux to linux-gnu.
+# Our host is $ARCH-slackware-linux not $ARCH-slackware-linux-gnu:
+sed -i -e 's#linux|linux-gnu|#linux|linux|#' config.sub
+
+CFLAGS="$SLKCFLAGS -DHOST='"'"${ARCH}-slackware-linux"'"'" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --mandir=/usr/man \
+ --enable-xkb \
+ --build=$ARCH-slackware-linux \
+ --host=$ARCH-slackware-linux \
+ --target=$ARCH-slackware-linux
+# --enable-gtk-doc-html=no \
+
+# See modules/input/Makefile.am
+make \
+ imconffiledir=/etc/gtk-3.0/$ARCH-slackware-linux \
+ $NUMJOBS || make || exit 1
+
+# Check the host value that is passed to the compile to the one in this script:
+host="$ARCH-slackware-linux"
+# Best I can tell, it doesn't matter if they match. Since gtk+3-3.2.0, both
+# build_triplet and host_triplet have "-gnu" appended to them, but neither of
+# those seem to actually be used anywhere. Commenting out unless I find out
+# that I'm wrong later... :-) --rworkman
+#compile_host=$(grep 'host_triplet =' gtk/Makefile | sed -e "s/.* = //")
+#if [ "x$compile_host" != "x$host" ]; then
+# echo "Host mismatch: compile='$compile_host', SlackBuild='$host'" && exit 1
+#fi
+
+make install \
+ imconffiledir=/etc/gtk-3.0/$ARCH-slackware-linux \
+ RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false \
+ DESTDIR=$PKG \
+ || exit 1
+
+# You'll probably need to install the newly made package right away to
+# fix the result of this next line, but we had to clear this. Sorry.
+rm -rf /etc/gtk-3.0
+# I'm spamming your root partition because /etc/gtk-3.0 won't install to $DESTDIR...
+make install imconffiledir=/etc/gtk-3.0/$ARCH-slackware-linux
+cp -a /etc/gtk-3.0 $PKG/etc || exit 1
+mv $PKG/etc/gtk-3.0/$host/im-multipress.conf $PKG/etc/gtk-3.0/im-multipress.conf.new
+rm -f $PKG/etc/gtk-3.0/$host/*
+if [ -r $PKG/etc/gtk-3.0/gtk.immodules ]; then
+ mv $PKG/etc/gtk-3.0/gtk.immodules $PKG/etc/gtk-3.0/$host/
+fi
+
+# Install a "starter" gtkrc
+echo 'gtk-theme-name="GTK+"' > $PKG/etc/gtk-3.0/gtkrc.new
+
+# We need to have separate 32-bit and 64-bit binaries
+# for places where we have two copies of the GTK+ package installed.
+# (we might have x86_64 and i486 packages on the same system, for example.)
+case "$host" in
+ s390x*|x86_64*)
+ mv $PKG/usr/bin/gtk-query-immodules-3.0{,-64}
+ ( cd $PKG/usr/bin
+ ln -sf gtk-query-immodules-3.0-64 gtk-query-immodules-3.0
+ )
+ ;;
+ *)
+ mv $PKG/usr/bin/gtk-query-immodules-3.0{,-32}
+ ( cd $PKG/usr/bin
+ ln -sf gtk-query-immodules-3.0-32 gtk-query-immodules-3.0
+ )
+ ;;
+esac
+
+# Install wrappers for the binaries:
+cp $CWD/update-gtk-immodules-3.0 $PKG/usr/bin/update-gtk-immodules-3.0
+chmod 0755 $PKG/usr/bin/update-*
+
+find $PKG | xargs file | egrep "executable|shared object" | grep "ELF" | \
+ cut -d: -f1 | xargs strip --strip-unneeded 2>/dev/null
+
+if [ -d $PKG/usr/man ]; then
+ ( cd $PKG/usr/man
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.*
+ )
+ done
+ )
+fi
+
+# Copy extra documentation into package.
+mkdir -p $PKG/usr/doc/gtk+3-$VERSION
+cp -a \
+ AUTHORS COPYING NEWS README \
+ $PKG/usr/doc/gtk+3-$VERSION
+( cd $PKG/usr/doc/gtk+3-$VERSION
+ ln -s /usr/share/gtk-doc/html/gail-libgail-util .
+ ln -s /usr/share/gtk-doc/html/gdk .
+ ln -s /usr/share/gtk-doc/html/gtk .
+)
+find $PKG/usr/doc/gtk+3-$VERSION/ -type f -exec chmod 644 {} \;
+chown -R root:root $PKG/usr/doc/gtk+3-$VERSION
+
+mkdir -p $PKG/install
+zcat $CWD/doinst.sh > $PKG/install/doinst.sh
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -p -l y -c n $TMP/gtk+3-${VERSION}-$ARCH-${BUILD}.txz
diff --git a/source/l/gtk+3/slack-desc b/source/l/gtk+3/slack-desc
new file mode 100644
index 000000000..47816927c
--- /dev/null
+++ b/source/l/gtk+3/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|' on
+# the right side marks the last column you can put a character in. You must make
+# exactly 11 lines for the formatting to be correct. It's also customary to
+# leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+gtk+3: GTK+ version 3 (multi-platform GUI toolkit)
+gtk+3:
+gtk+3: This is GTK+, a multi-platform toolkit for creating graphical user
+gtk+3: interfaces. Offering a complete set of widgets, GTK+ is suitable for
+gtk+3: projects ranging from small one-off projects to complete application
+gtk+3: suites.
+gtk+3:
+gtk+3:
+gtk+3:
+gtk+3:
+gtk+3:
diff --git a/source/l/gtk+3/update-gtk-immodules-3.0 b/source/l/gtk+3/update-gtk-immodules-3.0
new file mode 100644
index 000000000..06a705648
--- /dev/null
+++ b/source/l/gtk+3/update-gtk-immodules-3.0
@@ -0,0 +1,86 @@
+#! /bin/sh
+# Updates the immodules in /etc/gtk-3.0/$host
+
+umask 022
+
+# Get the machine type from uname:
+host=$(uname -m)-slackware-linux
+
+# Fix $host for arm arch:
+case "$host" in
+ arm*) host=arm-slackware-linux-gnueabi ;;
+esac
+
+# Deriving /etc/gtk-3.0/$host location
+#
+# We have had problems in the past with build systems
+# changing host from i386 to i686 and appending/dropping
+# the -gnu suffix, so try to match up the $host we got
+# with whats actually there.
+if [ ! -d /etc/gtk-3.0/$host ]; then
+ case "$host" in
+ i?86*)
+ for d in $(ls -d /etc/gtk-3.0/i?86*); do
+ host=$(basename $d)
+ break
+ done
+ ;;
+ esac
+fi
+
+FILE=/etc/gtk-3.0/$host/gtk.immodules
+
+case "$host" in
+ s390x*|x86_64*)
+ if [ -x /usr/bin/gtk-query-immodules-3.0-64 ]; then
+ if [ "$1" = "--verbose" ]; then
+ echo "Updating gtk.immodules for ${host}:"
+ echo " /usr/bin/gtk-query-immodules-3.0-64 \\"
+ echo " > $FILE"
+ fi
+ /usr/bin/gtk-query-immodules-3.0-64 > $FILE
+ # Check for x86_64 multilib:
+ if ls -d /etc/gtk-3.0/i?86* 1> /dev/null 2> /dev/null ; then
+ for d in $(ls -d /etc/gtk-3.0/i?86*); do
+ mlhost=$(basename $d)
+ break
+ done
+ if [ -r /etc/gtk-3.0/$mlhost/gtk.immodules -a \
+ -x /usr/bin/gtk-query-immodules-3.0-32 ]; then
+ FILE=/etc/gtk-3.0/$mlhost/gtk.immodules
+ if [ "$1" = "--verbose" ]; then
+ echo "Updating gtk.immodules for ${mlhost}:"
+ echo " /usr/bin/gtk-query-immodules-3.0-32 \\"
+ echo " > $FILE"
+ fi
+ /usr/bin/gtk-query-immodules-3.0-32 > $FILE
+ fi
+ fi
+ else
+ if [ "$1" = "--verbose" ]; then
+ echo "Updating gtk.immodules for ${host}:"
+ echo " /usr/bin/gtk-query-immodules-3.0 \\"
+ echo " > $FILE"
+ fi
+ /usr/bin/gtk-query-immodules-3.0 > $FILE
+ fi
+ ;;
+ *)
+ if [ -x /usr/bin/gtk-query-immodules-3.0-32 ]; then
+ if [ "$1" = "--verbose" ]; then
+ echo "Updating gtk.immodules for ${host}:"
+ echo " /usr/bin/gtk-query-immodules-3.0-32 \\"
+ echo " > $FILE"
+ fi
+ /usr/bin/gtk-query-immodules-3.0-32 > $FILE
+ else
+ if [ "$1" = "--verbose" ]; then
+ echo "Updating gtk.immodules for ${host}:"
+ echo " /usr/bin/gtk-query-immodules-3.0 \\"
+ echo " > $FILE"
+ fi
+ /usr/bin/gtk-query-immodules-3.0 > $FILE
+ fi
+ ;;
+esac
+
diff --git a/source/l/gtk+3/use_host_triplet_for_gtk_immodules.diff b/source/l/gtk+3/use_host_triplet_for_gtk_immodules.diff
new file mode 100644
index 000000000..92a8a121c
--- /dev/null
+++ b/source/l/gtk+3/use_host_triplet_for_gtk_immodules.diff
@@ -0,0 +1,11 @@
+diff -Nur gtk+-3.0.12.orig//gtk/Makefile.am gtk+-3.0.12/gtk/Makefile.am
+--- gtk+-3.0.12.orig//gtk/Makefile.am 2011-07-27 20:34:32.000000000 -0500
++++ gtk+-3.0.12/gtk/Makefile.am 2011-08-03 20:35:55.780035282 -0500
+@@ -37,6 +37,7 @@
+ -DGTK_LIBDIR=\"$(libdir)\" \
+ -DGTK_DATADIR=\"$(datadir)\" \
+ -DGTK_DATA_PREFIX=\"$(prefix)\" \
++ -DHOST=\"$(host_triplet)\" \
+ -DGTK_SYSCONFDIR=\"$(sysconfdir)\" \
+ -DGTK_VERSION=\"$(GTK_VERSION)\" \
+ -DGTK_BINARY_VERSION=\"$(GTK_BINARY_VERSION)\" \